import java.util.ArrayDeque;

void check(String str) {
    System.out.println(STR."\{str} \{checkImpl(str)}");
}

boolean checkImpl(String str) {
  var stack = new ArrayDeque<Character>();
  for (char ch : str.toCharArray()) {
    switch (ch) {
      case '(', '{', '[' -> {
        stack.push(ch);
      }
      case ')', '}', ']' -> {
        if (stack.isEmpty() || stack.pop() != ch - (ch == ')' ? 1 : 2)) {
          return false;
        }
      }
    }
  }
  return stack.isEmpty();
}

void main() {
  check("ab");
  check("()[]{}");
  check("a{b(c[d]e)f}g");
  check("a{b(c[d]e}f)g");
  check("ab)");
  check("a(b");
}
