import java.util.Arrays;
import java.util.Random;
import java.util.stream.Stream;

Random rand = new Random();
int[] quickSort(int[] a) {
  if (a.length <= 1) return a;
  int pivot = a[rand.nextInt(a.length)];
  return Stream.of(
      quickSort(Arrays.stream(a)
          .filter(x -> x < pivot).toArray()),
      Arrays.stream(a).filter(x -> x == pivot).toArray(),
      quickSort(Arrays.stream(a)
          .filter(x -> x > pivot).toArray())
  ).flatMapToInt(Arrays::stream).toArray();
}

void main() {
  int[] a = { 3, 1, 4, 1, 5, 9, 4, 2, 6 };
  int[] sorted = quickSort(a);
  System.out.println(Arrays.toString(sorted));
}
