import java.util.Arrays;
import java.util.ArrayDeque;
import java.util.Queue;
import java.util.stream.IntStream;

public class Main {
  public static void main(String[] args) {
    int[] data ={23, 76, 43, 9, 17, 32, 59};
    var builder = IntStream.builder();
    Queue<Integer> window = new ArrayDeque<>();
    var sum = 0;
    for (var n : data) {
      sum += n;
      window.offer(n);
      while (window.size() > 3) {
        sum -= window.poll();
      }
      if (window.size() == 3) builder.add(sum /3);
    }
    var result = builder.build().toArray();
    System.out.println(Arrays.toString(result));
  }
}
