public class Main {
  static int idx;

  static void check(String str) {
    idx = 0;
    System.out.println("%s %s".formatted(str, check(str, 0)));
  }

  static boolean check(String str, int paren) {
    for (; idx < str.length(); idx++) {
      char ch = str.charAt(idx);
      switch (ch) {
        case '(', '{', '[' -> {
          idx++;
          if (!check(str,ch)) return false;
        }
        case ')', '}', ']' -> {
          return ch == paren + (paren == '(' ? 1 : 2);
        }
      }
    }
    return paren == 0;
  }

  public static void main(String[] args) {
    check("ab");
    check("()[]{}");
    check("a{b(c[d]e)f}g");
    check("a{b(c[d]e}f)g");
    check("ab)");
    check("a(b");
  }
}
